﻿
Imports System.Collections.Generic

Public Class Form1

    Friend myResizer As Resizer = New Resizer
    Friend ControlsRatio As SizeF

    Private Sub Form1_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        EventsAreEnabled = False
        ShowWindowTitle()
        SetInitialButtonNamesAndPositions()
        ' ------------------------------------------- resizer
        myResizer.Init(Me)
        myResizer.DisableFontResize(RTB)
        ' -------------------------------------------
        Me.BackColor = Color_Form
        GBox_Controls.BackColor = Color_Panels
        GBox_Program.BackColor = Color_PanelEditing
        PreparePanelsForProgram()
        PictureBox1.Visible = False
        WMP.SendToBack()
        Form_Debug.Show()
        Form_Debug.Hide()
        Load_INI()
        RTB_and_PrintTextBox_Init()
        ' -------------------------------------------
        Load_Program()
        ' ------------------------------------------- hide the form if the load program timeout has shown it
        Me.Opacity = 0
        Me.Hide()
        ' -------------------------------------------
        Form_Debug.chk_PauseButtonSlot_Update()
        Form_Debug.chk_SendToRecycleBin_Update()
        ApplyEditorProps()
        EventsAreEnabled = True
        SetViewMode()
        ShowInTaskbar = False
        ShowInTaskbar = True
        If Running Then
            StartRunning(True, 0)
        Else
            StopRunning(False, False)
            'RTB.ShowSuggestions(StatusLabel1, Label_Lines)
            StatusLabel1.BackColor = Color.FromArgb(220, 255, 200)
        End If
        ShowHideTextAndTools()
        ' ------------------------------------------- resizer
        If ControlsRatio.Width <> 0 And _
           ControlsRatio.Height <> 0 Then
            myResizer.ResizeAllControls_FixedRatio(Me, ControlsRatio)
        End If
        ' -------------------------------------------
        Me.Hide()
        Me.Show()
        WMP_Init()
        RTB.Focus()
        ' ------------------------------------------- show all
        Refresh()
        Form_Debug.Refresh()
        Application.DoEvents()
        SetFormOpacity()
        Form_Debug.Opacity = 1
        ' ------------------------------------------- start all
        SchedulerMaxPrecision()
        TimerSlow.Interval = 50
        TimerSlow.Start()
        TimerFast.Interval = 15
        TimerFast.Start()
        ' ------------------------------------------- TEST FONTS
        'OpenFontsPanel()
    End Sub

    Friend Sub ShowWindowTitle()
        Text = AppTitleAndVersion() + "  -  Program :  " + IO.Path.GetFileName(ProgramFile_PathAndName)
    End Sub

    Friend Sub ShowProgramTitle()
        ShowHideTextAndTools()
    End Sub

    Private Sub Form1_FormClosing(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing
        e.Cancel = False
        CloseAll()
    End Sub

    Private Sub CloseAll()
        ' --------------------------------- Event ClosingApp (dangerous if the user does not terminate with End)
        'CopyRtbLines()
        'ExecTheLine(0, "Goto ClosingApp")
        'Do
        '    Application.DoEvents()
        'Loop Until Running = False
        ' --------------------------------- stop all
        TimerSlow.Stop()
        TimerFast.Stop()
        ExecutionThread_Stop()
        ShedulerDefaultPrecision()
        COM_Close()
        ' --------------------------------- save slots and vars
        SaveSlots()
        SaveVars()
        ' ---------------------------------
        EventsAreEnabled = False
        Form_Input.Close()
        WMP.URL = Nothing
        SaveProgram_IfChanged()
        Save_INI()
        'ShowTrayWnd()
    End Sub

    Private Sub Form_LocationChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.LocationChanged
        Form1_Location = Me.Location
        If Not EventsAreEnabled Then Exit Sub
        LimitFormPosition(Me)
    End Sub

    Private OldWindowState As FormWindowState
    Private Sub Form1_Resize(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Resize
        ' 
        ' ------------------------------------------------------------------ resize controls
        If My.Computer.Keyboard.CtrlKeyDown AndAlso _
           My.Computer.Keyboard.ShiftKeyDown AndAlso _
           Me.WindowState <> FormWindowState.Minimized Then
            myResizer.ResizeAllControls(Me)
        End If
        ' ------------------------------------------------------------------ Set Visible Buttons
        SetVisibleButtons()
        ' ------------------------------------------------------------------ ViewMode = Maximized/Sizable
        If Not EventsAreEnabled Then Exit Sub
        If Me.WindowState <> OldWindowState Then
            OldWindowState = Me.WindowState
            Select Case Me.WindowState
                Case FormWindowState.Maximized
                    ViewMode = ViewModes.Maximized
                Case FormWindowState.Normal
                    ViewMode = ViewModes.Sizable
                    Me.FormBorderStyle = Windows.Forms.FormBorderStyle.Sizable
            End Select
            RedrawRtbUnscrolled()
        End If
        ' ------------------------------------------------------------------ ensure low controls visible
        GBox_Program.Height = GBox_Controls.Height
        ' ------------------------------------------------------------------
        ShowHideTextAndTools()
        ' ------------------------------------------------------------------ ViewMode = Sizable
        If Not Running Then
            ViewMode = ViewModes.Sizable
        End If
        ' ------------------------------------------------------------------ min size and normal size
        Select Case ViewMode
            Case ViewModes.MinSize
                MinSizeWidth = Me.Width
                MinSizeHeight = Me.Height
            Case ViewModes.Sizable
                NormalSizeWidth = Me.Width
                NormalSizeHeight = Me.Height
        End Select
    End Sub

    Private Sub Form1_ResizeEnd(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.ResizeEnd
        RTB.Invalidate()
    End Sub

    Private Sub RedrawRtbUnscrolled()
        ' ------- Force the RTB window to show all the text un-scrolled
        ' ------- otherwise some part of the text could be not visible
        Dim oldzoom As Single = RTB.ZoomFactor
        RTB.ZoomFactor = 0.1
        RTB.ZoomFactor = oldzoom
    End Sub

    Friend Sub SetStatusLabelFontProportional()
        StatusLabel1.Font = New Font("Arial", 11 * myResizer.GetRatio.Height, FontStyle.Bold)
    End Sub

    Friend Sub SetStatusLabelFontFixed()
        StatusLabel1.Font = New Font("Lucida console", 13 * myResizer.GetRatio.Height, FontStyle.Bold)
    End Sub

    ' =============================================================================================
    '  MenuStrip, ToolStrip and RichTextBox accepting the first click
    '  If the form is not focused and receives a WM_PARENTNOTIFY (528) message
    '  then the form is activated before to exec the message
    ' ---------------------------------------------------------------------------------------------
    '  In addition the "TopMost" brings the window on the top 
    ' =============================================================================================
    <DebuggerStepThrough()> _
    Protected Overrides Sub WndProc(ByRef m As Message)
        If m.Msg = 528 AndAlso Not Me.Focused Then
            Me.Activate()
            Me.TopMost = True
            Me.TopMost = False
        End If
        MyBase.WndProc(m)
    End Sub

    ' -----------------------------------------------------------------------------------------------------
    '  SHOW and HIDE Text and TOOLS
    ' ----------------------------------------------------------------------------------------------------- 
    Private Sub ShowHideTextAndTools()
        ' --------------------------------------------------------------------- hide/show program text
        Dim GBoxProgramTextLength As Single
        Dim txt As String = "Program :  " + IO.Path.GetFileName(ProgramFile_PathAndName)
        GBoxProgramTextLength = TextRenderer.MeasureText(txt, GBox_Program.Font).Width
        If GBoxProgramTextLength + 10 < chk_Comment.Left Then
            GBox_Program.Text = txt
        Else
            GBox_Program.Text = ""
        End If
        ' --------------------------------------------------------------------- hide/show tools
        chk_Comment.Visible = chk_Comment.Left > 10
        chk_Uncomment.Visible = chk_Uncomment.Left > 10
        chk_HistoryBack.Visible = chk_HistoryBack.Left > 10
        chk_HistoryForward.Visible = chk_HistoryForward.Left > 10
        chk_GoToNextOccurrence.Visible = chk_GoToNextOccurrence.Left > 10
        chk_GotoDeclaration.Visible = chk_GotoDeclaration.Left > 10
        chk_Debug.Visible = chk_Debug.Left > 10
        ' --------------------------------------------------------------------- hide/show label_lines
        Label_Lines.Visible = Label_Lines.Left > tkbar_Transparency.Right
        ' --------------------------------------------------------------------- hide/show speed zoom opacity
        tkbar_Speed.Visible = tkbar_Speed.Right + 10 < GBox_Program.Width
        tkbar_Zoom.Visible = tkbar_Zoom.Right + 10 < GBox_Program.Width
        tkbar_Transparency.Visible = tkbar_Transparency.Right + 10 < GBox_Program.Width
    End Sub

    ' -----------------------------------------------------------------------------------------------------
    '  TOOLS
    ' -----------------------------------------------------------------------------------------------------
    Private Sub chk_HistoryBack_Click(ByVal sender As Object, ByVal e As EventArgs) Handles chk_HistoryBack.Click
        RTB.History_Back()
        RTB.Focus()
    End Sub
    Private Sub chk_HistoryForward_Click(ByVal sender As Object, ByVal e As EventArgs) Handles chk_HistoryForward.Click
        RTB.History_Forward()
        RTB.Focus()
    End Sub
    Private Sub chk_Comment_Click(ByVal sender As Object, ByVal e As EventArgs) Handles chk_Comment.Click
        RTB.CommentSelectedLines(True)
        RTB.Focus()
    End Sub
    Private Sub chk_Uncomment_Click(ByVal sender As Object, ByVal e As EventArgs) Handles chk_Uncomment.Click
        RTB.CommentSelectedLines(False)
        RTB.Focus()
    End Sub
    Private Sub chk_GotoNextWordOccurrence_Click(ByVal sender As Object, ByVal e As EventArgs) Handles chk_GoToNextOccurrence.Click
        RTB.GoToNextOccurrence()
        RTB.Focus()
    End Sub
    Private Sub chk_GotoDeclaration_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles chk_GotoDeclaration.Click
        RTB.GoToDeclaration()
        RTB.Focus()
    End Sub
    Private Sub chk_Debug_Click(ByVal sender As Object, ByVal e As EventArgs) Handles chk_Debug.Click
        If Form_Debug.Visible Then
            Form_Debug.Hide()
        Else
            Form_Debug.Show()
        End If
    End Sub

    Private Sub ShowTools()
        chk_HistoryBack.Visible = True
        chk_HistoryForward.Visible = True
        chk_Comment.Visible = True
        chk_Uncomment.Visible = True
        chk_GoToNextOccurrence.Visible = True
        chk_Debug.Visible = True
    End Sub
    Private Sub HideTools()
        chk_HistoryBack.Visible = False
        chk_HistoryForward.Visible = False
        chk_Comment.Visible = False
        chk_Uncomment.Visible = False
        chk_GoToNextOccurrence.Visible = False
        chk_Debug.Visible = False
    End Sub


    ' -----------------------------------------------------------------------------------------------------
    '  CONTEXTUAL MENU - EDITOR
    ' -----------------------------------------------------------------------------------------------------
    Private RTB_MousePos As Point
    Private Sub MenuStrip_Edit_Opening(ByVal sender As Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles MenuStrip_Edit.Opening
        RTB_MousePos = RTB.PointToClient(MousePosition)
        MenuStrip_Edit.Show(RTB, RTB_MousePos.X + 100, RTB_MousePos.Y + 20)
    End Sub
    Private Sub MenuStrip_Edit_Debug_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MenuStrip_Edit_Debug.Click
        Form_Debug.Show()
    End Sub
    Private Sub MenuStrip_Edit_ToggleBreakpoint_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MenuStrip_Edit_ToggleBreakpoint.Click
        RTB.ToggleBreakPoint(RTB_MousePos)
    End Sub
    Private Sub MenuStrip_Edit_DeleteAllBreakpoints_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MenuStrip_Edit_DeleteAllBreakpoints.Click
        RTB.DeleteAllBreakPoints()
    End Sub
    Private Sub MenuStrip_Edit_GoBack_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MenuStrip_Edit_GoBack.Click
        RTB.History_Back()
        RTB.Focus()
    End Sub
    Private Sub MenuStrip_Edit_GoForward_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MenuStrip_Edit_GoForward.Click
        RTB.History_Forward()
        RTB.Focus()
    End Sub
    Private Sub MenuStrip_Edit_GotoNextWordOccurrence_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MenuStrip_Edit_GoToNextOccurrence.Click
        RTB.GoToNextOccurrence()
    End Sub
    Private Sub MenuStrip_Edit_GotoDeclaration_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MenuStrip_Edit_GoToDeclaration.Click
        RTB.GoToDeclaration()
    End Sub
    Private Sub MenuStrip_Edit_Cut_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MenuStrip_Edit_Cut.Click
        RTB.ExecCut()
    End Sub
    Private Sub MenuStrip_Edit_Copy_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MenuStrip_Edit_Copy.Click
        RTB.ExecCopy()
    End Sub
    Private Sub MenuStrip_Edit_Paste_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MenuStrip_Edit_Paste.Click
        RTB.ExecPaste()
    End Sub
    Private Sub MenuStrip_Edit_Delete_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MenuStrip_Edit_Delete.Click
        RTB.ExecDelete()
    End Sub
    Private Sub MenuStrip_Edit_SelectAll_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MenuStrip_Edit_SelectAll.Click
        RTB.SelectAll()
    End Sub
    Private Sub MenuStrip_Edit_Comment_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MenuStrip_Edit_Comment.Click
        RTB.CommentSelectedLines(True)
    End Sub
    Private Sub MenuStrip_Edit_Uncomment_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MenuStrip_Edit_Uncomment.Click
        RTB.CommentSelectedLines(False)
    End Sub
    Private Sub MenuStrip_Edit_Find_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MenuStrip_Edit_Find.Click
        Editor_Find()
    End Sub
    Private Sub MenuStrip_Edit_Replace_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MenuStrip_Edit_Replace.Click
        Editor_FindReplace()
    End Sub
    Private Sub MenuStrip_Edit_ChangeFont_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MenuStrip_Edit_ChangeFont.Click
        OpenFontsPanel()
    End Sub


    ' ===============================================================================================================
    '  FONTS
    ' ===============================================================================================================
    Friend FontName As String

    Private Sub OpenFontsPanel()
        ' ------------------------------------------------------------------------------
        GBox_Fonts.Parent = Me
        GBox_Fonts.Location = GBox_Controls.Location
        GBox_Fonts.Size = GBox_Controls.Size
        GBox_Fonts.BringToFront()
        GBox_Fonts.Visible = True
        ' ------------------------------------------------------------------------------
        Dim sa() As String = GetInstalledFontNames_Monospaced()
        ListBox_Fonts.Items.Clear()
        ListBox_Fonts.Items.AddRange(sa)
        ' ------------------------------------------------------------------------------
        EventsAreEnabled = False
        ListBox_Fonts.SelectedItem = ListBox_Fonts.Items(ListBox_Fonts.Items.IndexOf(FontName))
        EventsAreEnabled = True
        ' ------------------------------------------------------------------------------
        ListBox_Fonts.Focus()
    End Sub

    Private Sub ListBox_Fonts_KeyUp(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyEventArgs) Handles ListBox_Fonts.KeyUp
        ListBox_Fonts.Focus()
    End Sub

    Private Sub ListBox_Fonts_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ListBox_Fonts.SelectedIndexChanged
        If Not EventsAreEnabled Then Exit Sub
        SetNewFont(ListBox_Fonts.SelectedItem.ToString)
        ListBox_Fonts.Focus()
    End Sub

    Friend Sub SetNewFont(ByVal fname As String)
        FontName = fname
        RTB_and_PrintTextBox_Init()
        If RTBLines.Length < 200 Then RTB.ColorAllLines()
        Save_INI()
    End Sub

    Private Sub chk_OpenFontsFolder_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles chk_OpenFontsFolder.Click
        OpenFontsFolder()
    End Sub
    Private Sub chk_InstallNewFonts_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles chk_InstallNewFonts.Click
        InstallNewFonts()
    End Sub
    Private Sub chk_CloseFontPanel_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles chk_CloseFontPanel.Click
        GBox_Fonts.Visible = False
        If RTBLines.Length >= 200 Then RTB.ColorAllLines()
    End Sub

    ' ===============================================================================================================
    '  FIND - REPLACE and Options
    ' ===============================================================================================================
    Friend Sub Editor_Find()
        With Form_Replace
            .TopMost = True
            .DialogType = Form_Replace.DialogTypeValue.Find
            .OwnerCodeBox = RTB
            .Show()
            .txtFind.Focus()
        End With
    End Sub
    Friend Sub Editor_FindReplace()
        With Form_Replace
            .TopMost = True
            .DialogType = Form_Replace.DialogTypeValue.Replace
            .OwnerCodeBox = RTB
            .Show()
            .txtFind.Focus()
        End With
    End Sub

    ' =============================================================================================
    '  APPLICATION CONTROLS
    ' ============================================================================================= 
    Private Sub chk_ControlsBack_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles chk_ControlsBack.Click
        RTB.History_Back()
        RTB.Focus()
        chk_ControlsBack.Checked = False
    End Sub
    Private Sub chk_ControlsForward_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles chk_ControlsForward.Click
        RTB.History_Forward()
        RTB.Focus()
        chk_ControlsForward.Checked = False
    End Sub
    Private Sub chk_ControlsGoToNext_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles chk_ControlsGoToNext.Click
        RTB.GoToNextOccurrence()
        RTB.Focus()
        chk_ControlsGoToNext.Checked = False
    End Sub
    Private Sub chk_ControlsGoToDeclaration_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles chk_ControlsGoToDeclaration.Click
        RTB.GoToDeclaration()
        RTB.Focus()
        chk_ControlsGoToDeclaration.Checked = False
    End Sub
    Private Sub chk_ControlsUndo_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles chk_ControlsUndo.Click
        RTB.ExecUndo()
        RTB.Focus()
        chk_ControlsUndo.Checked = False
    End Sub
    Private Sub chk_ControlsRedo_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles chk_ControlsRedo.Click
        RTB.ExecRedo()
        RTB.Focus()
        chk_ControlsRedo.Checked = False
    End Sub
    Private Sub chk_ControlsLoad_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles chk_ControlsLoad.Click
        LoadProgramDialog()
        RTB.Focus()
        chk_ControlsLoad.Checked = False
    End Sub
    Private Sub chk_ControlsSave_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles chk_ControlsSave.Click
        SaveProgramDialog()
        RTB.Focus()
        chk_ControlsSave.Checked = False
    End Sub
    Private Sub chk_ControlsRun_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles chk_ControlsRun.Click
        If chk_ControlsRun.Checked Then
            StopRunning()
        Else
            StartRunning(True, 0)
        End If
    End Sub

    Private Sub txt_WebBrowserURL_KeyDown(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyEventArgs) Handles txt_WebBrowserURL.KeyDown
        If e.KeyCode = Keys.Return Then
            e.SuppressKeyPress = True
            e.Handled = True
            Dim url As String = txt_WebBrowserURL.Text
            If Not url.StartsWith("http") Then url = "http://" + url
            WB.Navigate(url)
        End If
    End Sub

    Private WB_zoom As Int32 = 100
    Private Sub Form1_KeyDown(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyEventArgs) Handles Me.KeyDown
        '
        If Running Then
            ' ------------------------------------------------------------- STOP RUNNING with SHIFT-ESC and ALT-E
            If e.KeyCode = Keys.Escape AndAlso _
               My.Computer.Keyboard.ShiftKeyDown Then
                If ViewMode = ViewModes.FullScreen Then SetViewMode_ThreadSafe(ViewModes.Maximized)
                StopRunning()
            End If
            If e.KeyCode = Keys.E AndAlso _
               My.Computer.Keyboard.AltKeyDown Then
                If ViewMode = ViewModes.FullScreen Then SetViewMode_ThreadSafe(ViewModes.Maximized)
                StopRunning()
            End If
            ' ------------------------------------------------------------- STOP RUNNING with F8
            If e.KeyCode = Keys.F8 AndAlso Not Form_Debug.Visible Then
                StopRunning()
            End If
            ' ------------------------------------------------------------- if WEB navigating then KEYS are disabled
            If PanelMode = PanelModes.Web Then
                Return
            End If
            ' ------------------------------------------------------------- supress keys
            If Not PrintTextBox.Visible Then
                e.SuppressKeyPress = True
                e.Handled = True
            End If
            ' ------------------------------------------------------------- EXEC KEYS
            ExecKeysEvent(e.KeyCode)
        Else
            ' ------------------------------------------------------------- STEP if debugging with F5 
            If e.KeyCode = Keys.F5 Then
                If Debugging Then
                    Form_Debug.DoSingleStep()
                End If
            End If
            ' ------------------------------------------------------------- RUN with F8 or ALT+R 
            If e.KeyCode = Keys.F8 OrElse _
                (e.KeyCode = Keys.R AndAlso My.Computer.Keyboard.AltKeyDown) Then
                If Form_Debug.Visible Then
                    Form_Debug.chk_Run.Checked = Not Form_Debug.chk_Run.Checked
                Else
                    StartRunning(True, 0)
                End If
            End If
            ' ------------------------------------------------------------- CUT / COPY / PASTE / UNDO / REDO
            If My.Computer.Keyboard.CtrlKeyDown Then
                RTBLines = RTB.Lines
                e.SuppressKeyPress = True
                e.Handled = True
                Select Case e.KeyCode
                    Case Keys.F : Editor_Find()
                    Case Keys.X : RTB.ExecCut()
                    Case Keys.C : RTB.ExecCopy()
                    Case Keys.V : RTB.ExecPaste()
                    Case Keys.Z : RTB.ExecUndo()
                    Case Keys.Y : RTB.ExecRedo()
                    Case Keys.Space : RTB.CompleteKeyword()
                    Case Else
                        e.Handled = False
                        e.SuppressKeyPress = False
                End Select
            End If
        End If
    End Sub

    Private Sub Form1_KeyUp(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyEventArgs) Handles Me.KeyUp
        RTB.Focus()
        KeyEventsStackIndex = 99999
    End Sub

    ' --------------------------------------------------------------
    '  Sometimes the Arrow Keys does not generate the KeyDown event
    '  this happens mainly with KeyPreview = True
    '  when some control does not transfer the event properly
    ' --------------------------------------------------------------
    '  In the CmdKeys are included also SHIFT, CTRL and ALT
    '  so you could add them in the IF to ensure the KeyDown
    ' --------------------------------------------------------------
    Protected Overrides Function ProcessCmdKey(ByRef msg As Message, ByVal keydata As Keys) As Boolean
        If Running Then
            keydata = keydata And Not Keys.Shift
            If keydata = Keys.Right Or keydata = Keys.Left Or keydata = Keys.Up Or keydata = Keys.Down Then
                OnKeyDown(New KeyEventArgs(keydata))
                ProcessCmdKey = True
            Else
                ProcessCmdKey = MyBase.ProcessCmdKey(msg, keydata)
            End If
        Else
            ProcessCmdKey = MyBase.ProcessCmdKey(msg, keydata)
        End If
    End Function


    ' =============================================================================================
    '  STATUS BAR KEYWORDS
    ' =============================================================================================
    Private Sub StatusLabel1_MouseDown(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles StatusLabel1.MouseDown
        If e.Button = Windows.Forms.MouseButtons.Left Then
            Dim s As String = GetClickedWord(StatusLabel1, e.Location)
            s = s.Replace("""", "")
            s = s.Replace(",", "")
            s = s.Replace(".", "")
            Select Case s.ToLower
                Case "eventstop", "eventtimer", "flashing", "yellow", "blue", "red"
                    ' ----------------------------------------------------------------- add a space if needed
                    Dim s2 As String = RTBLines(RTB.GetFirstSelectedLine)
                    If s2.ToLower.EndsWith("color") Then
                        RTB.AddFinalSpace_ToRow()
                    End If
                    ' ----------------------------------------------------------------- complete keyword
                    RTB.CompleteKeyword_MouseSelected(s)
                Case Else
                    If StatusLabel1.Text.ToLower.StartsWith("keywords:") Then
                        If s <> "" And s.ToLower <> "keywords:" Then
                            RTB.CompleteKeyword_MouseSelected(s)
                        End If
                    End If
            End Select
        Else
            '
        End If
    End Sub

    Private Sub chk_Suggestions_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles chk_Suggestions.Click
        Select Case RTB.SuggestionsButtonType
            Case "Colors"
                ' ----------------------------------------------------------------- add a space if needed
                Dim s As String = RTBLines(RTB.GetFirstSelectedLine)
                If s.ToLower.EndsWith("color") Then
                    RTB.AddFinalSpace_ToRow()
                End If
                ' ----------------------------------------------------------------- open the color selector
                Form_Suggestions.Height = 650
                Form_Suggestions.Text = "Theremino Automation - Color Selector"
                Form_Suggestions.StartPosition = FormStartPosition.CenterScreen
                Form_Suggestions.ShowDialog()
        End Select
    End Sub




    ' =============================================================================================
    '  RICH TEXT BOX EDITOR
    ' =============================================================================================
    Private Color_Form As Color = Color.FromArgb(220, 220, 240)
    Private Color_Panels As Color = Color.FromArgb(240, 240, 240)
    Private Color_PanelEditing As Color = Color.FromArgb(240, 220, 180)
    Private Color_PanelRunning As Color = Color.FromArgb(190, 220, 170) '210, 240, 190) ' TODO
    Private Color_BackEditing As Color = Color.FromArgb(255, 250, 240)
    Private Color_BackRunning As Color = Color.FromArgb(210, 210, 210)  '230, 230, 230) ' TODO

    Private Sub RTB_and_PrintTextBox_Init()
        FontName = GetValidFontName_Monospaced(FontName)
        With RTB
            .AcceptsTab = True
            .DetectUrls = False
            .WordWrap = False
            .HideSelection = False
            ' The font-size determines the number of spaces for each TAB
            ' with font-size 15 each TAB is similar to 4 spaces
            .Font = New Font(FontName, 15, FontStyle.Regular)
            .AutoWordSelection = True
            .AutoWordSelection = False
        End With
        With PrintTextBox
            .ReadOnly = False
            .AcceptsTab = True
            .DetectUrls = False
            .WordWrap = True
            .HideSelection = False
            .BackColor = Color.FromArgb(255, 255, 220)
            .Font = New Font(FontName, 15, FontStyle.Regular)
            .AutoWordSelection = True
            .AutoWordSelection = False
        End With
    End Sub

    Private Sub TrackBars_MouseLeave(ByVal sender As Object, ByVal e As System.EventArgs) Handles tkbar_Speed.MouseLeave, _
                                                                                                  tkbar_Zoom.MouseLeave, _
                                                                                                  tkbar_Transparency.MouseLeave
        RTB.Focus()
    End Sub
    Private Sub tkbar_Speed_ValueChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tkbar_Speed.ValueChanged
        If Not EventsAreEnabled Then Return
        ApplyEditorProps()
        ShowExecutionDelayText(tkbar_Speed.Value)
    End Sub
    Private Sub tkbar_Zoom_ValueChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tkbar_Zoom.ValueChanged
        If Not EventsAreEnabled Then Return
        ApplyEditorProps()
    End Sub

    Friend Sub ApplyEditorProps(Optional ByVal ForceNewZoom As Boolean = False)
        Dim z As Int32 = tkbar_Zoom.Value + 3
        Dim NewRtbZoom As Single = z / 11.0F
        If NewRtbZoom <> RTB.ZoomFactor Then
            If ForceNewZoom Then
                RTB.ZoomFactor = 0.1
                PrintTextBox.ZoomFactor = 0.1
            End If
            RTB.ZoomFactor = NewRtbZoom
            PrintTextBox.ZoomFactor = NewRtbZoom
        End If
        MenuStrip_Edit.Font = New Font("Tahoma", 8 + CInt(z * 0.6))
        MenuStrip_Exit.Font = New Font("Tahoma", 8 + CInt(z * 0.6))
        Form_Debug.ListView1.Font = New Font("Microsoft Sans Serif", 6 + CInt(z * 0.5))
        SetExecutionDelayParams(tkbar_Speed.Value)
    End Sub

    Private Sub tkbar_Transparency_ValueChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tkbar_Transparency.ValueChanged
        If Not EventsAreEnabled Then Return
        SetFormOpacity()
    End Sub

    Private Sub SetFormOpacity()
        Me.Opacity = 1 - tkbar_Transparency.Value / 20.0F
    End Sub

    ' ================================================================================================
    '  STOP RUNNING
    ' ================================================================================================
    Private FirstVisibleLine_BeforeMouseStop As Int32 = -1
    Private SelectionStart_BeforeMouseStop As Int32

    Private Sub RTB_MouseDown(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles RTB.MouseDown
        If Running Then
            If e.Button = Windows.Forms.MouseButtons.Left Then
                RTB.PaintEventEnabled = False
                SelectionStart_BeforeMouseStop = RTB.SelectionStart
                FirstVisibleLine_BeforeMouseStop = RTB.GetFirstVisibleLine()
                StopRunning()
                RestoreFirstVisibleLine_BeforeMouseStop()
            End If
        End If
    End Sub

    Private Sub RestoreFirstVisibleLine_BeforeMouseStop()
        If FirstVisibleLine_BeforeMouseStop < 0 Then Return
        RTB.ScrollToLine(FirstVisibleLine_BeforeMouseStop)
        RTB.SelectionStart = SelectionStart_BeforeMouseStop
        RTB.SelectionLength = 0
        RTB.PaintEventEnabled = True
    End Sub


    ' =============================================================================================
    '  PROGRAMMABLE BUTTONS
    ' =============================================================================================
    Private Const NBUTTONS As Int32 = 32
    Private ButtonSlots(NBUTTONS - 1) As Int32
    Private ButtonSlotsOldValues(NBUTTONS - 1) As Single
    Private ButtonFlashingFrequency(NBUTTONS - 1) As Single
    Private ButtonFlashingTimer(NBUTTONS - 1) As Single
    Private ButtonFlashingColor1(NBUTTONS - 1) As Color
    Private ButtonFlashingColor2(NBUTTONS - 1) As Color

    Private Sub Buttons_Click(ByVal sender As Object, ByVal e As System.EventArgs) _
                                                                    Handles Button_1.Click, _
                                                                            Button_2.Click, _
                                                                            Button_3.Click, _
                                                                            Button_4.Click, _
                                                                            Button_5.Click, _
                                                                            Button_6.Click, _
                                                                            Button_7.Click, _
                                                                            Button_8.Click, _
                                                                            Button_9.Click, _
                                                                            Button_10.Click, _
                                                                            Button_11.Click, _
                                                                            Button_12.Click, _
                                                                            Button_13.Click, _
                                                                            Button_14.Click, _
                                                                            Button_15.Click, _
                                                                            Button_16.Click, _
                                                                            Button_17.Click, _
                                                                            Button_18.Click, _
                                                                            Button_19.Click, _
                                                                            Button_20.Click, _
                                                                            Button_21.Click, _
                                                                            Button_22.Click, _
                                                                            Button_23.Click, _
                                                                            Button_24.Click, _
                                                                            Button_25.Click, _
                                                                            Button_26.Click, _
                                                                            Button_27.Click, _
                                                                            Button_28.Click, _
                                                                            Button_29.Click, _
                                                                            Button_30.Click, _
                                                                            Button_31.Click, _
                                                                            Button_32.Click
        ExecButton(CType(sender, CheckBox))
    End Sub
    Private Function GetButtonByIndex(ByVal i As Int32) As CheckBox
        Select Case i
            Case 1 : Return Button_1
            Case 2 : Return Button_2
            Case 3 : Return Button_3
            Case 4 : Return Button_4
            Case 5 : Return Button_5
            Case 6 : Return Button_6
            Case 7 : Return Button_7
            Case 8 : Return Button_8
            Case 9 : Return Button_9
            Case 10 : Return Button_10
            Case 11 : Return Button_11
            Case 12 : Return Button_12
            Case 13 : Return Button_13
            Case 14 : Return Button_14
            Case 15 : Return Button_15
            Case 16 : Return Button_16
            Case 17 : Return Button_17
            Case 18 : Return Button_18
            Case 19 : Return Button_19
            Case 20 : Return Button_20
            Case 21 : Return Button_21
            Case 22 : Return Button_22
            Case 23 : Return Button_23
            Case 24 : Return Button_24
            Case 25 : Return Button_25
            Case 26 : Return Button_26
            Case 27 : Return Button_27
            Case 28 : Return Button_28
            Case 29 : Return Button_29
            Case 30 : Return Button_30
            Case 31 : Return Button_31
            Case 32 : Return Button_32
            Case Else : Return Nothing
        End Select
    End Function
    Friend Sub SetInitialButtonNamesAndPositions()
        For i As Int32 = 1 To NBUTTONS
            SetButton_ThreadSafe(i, "")
            Dim b As CheckBox = GetButtonByIndex(i)
            b.BackColor = Color.OldLace
            b.ForeColor = Color.Black
            b.FlatAppearance.MouseOverBackColor = ModifiedColor(b.BackColor, 90)
            ButtonFlashingFrequency(i - 1) = 0
            b.FlatAppearance.BorderSize = 1
            b.FlatAppearance.BorderColor = Color.Gray
        Next
        For i As Int32 = 2 To NBUTTONS
            Dim b As CheckBox = GetButtonByIndex(i)
            If i <= 16 Then
                b.Left = GetButtonByIndex(1).Left
                b.Top = GetButtonByIndex(i - 1).Bottom + 2
            Else
                b.Left = GetButtonByIndex(1).Right + 4
                b.Top = GetButtonByIndex(i - 16).Top
            End If
        Next
        SetVisibleButtons()
    End Sub


    Private Sub SetVisibleButtons()
        ' ---------------------------------------------------------------
        If Not EventsAreEnabled Then Return
        ' ---------------------------------------------------------------
        Dim b As CheckBox
        Dim ypos As Int32
        Dim ButtonsAfter16 As Boolean = False
        If Running Then
            ypos = chk_ControlsRun.Top - 2
        Else
            ypos = chk_ControlsGoToDeclaration.Top - 2
        End If
        For i As Int32 = 1 To NBUTTONS
            b = GetButtonByIndex(i)
            If b.Text <> Nothing Then
                If i > 16 Then
                    ButtonsAfter16 = True
                    b.Visible = b.Bottom < GBox_Controls.ClientSize.Height - 4
                Else
                    b.Visible = b.Bottom < ypos
                End If
                SetButtonFontSize(b)
            Else
                b.Visible = False
            End If
        Next
        ' ---------------------------------------------------------------
        If ButtonsAfter16 Then
            GBox_Controls.Width = Button_17.Right + Button_1.Left
        Else
            GBox_Controls.Width = Button_1.Right + Button_1.Left
        End If
        ' ---------------------------------------------------------------
        Me.MinimumSize = New Size(GBox_Program.Left + 16, Button_1.Height * 7)
        ' ---------------------------------------------------------------
        GBox_Program.Left = GBox_Controls.Right + 6
        GBox_Program.Width = Me.ClientSize.Width - GBox_Program.Left - 8
        ' ---------------------------------------------------------------
        ShowHideTextAndTools()
    End Sub
    Private Sub ResetButtonSlots()
        For i As Int32 = 1 To NBUTTONS
            ButtonSlots(i - 1) = -1
        Next
    End Sub
    Private Sub DisableProgrammableButtons()
        For i As Int32 = 1 To NBUTTONS
            GetButtonByIndex(i).Enabled = False
        Next
    End Sub
    Private Sub EnableProgrammableButtons()
        For i As Int32 = 1 To NBUTTONS
            GetButtonByIndex(i).Enabled = True
        Next
    End Sub
    Private Sub UncheckProgrammableButtons()
        For i As Int32 = 1 To NBUTTONS
            GetButtonByIndex(i).Checked = False
        Next
    End Sub

    Private Sub ExecButtonsFromSlots()
        For i As Int32 = 0 To NBUTTONS - 1
            If ButtonSlots(i) >= 0 Then
                Dim NewValue As Single = Slots.ReadSlot_NoNan(ButtonSlots(i))
                If NewValue > 500 And ButtonSlotsOldValues(i) <= 500 Then
                    Dim button As CheckBox
                    button = GetButtonByIndex(i + 1)
                    If button.Enabled Then
                        button.Checked = True
                        ExecButton(button)
                    End If
                End If
                ButtonSlotsOldValues(i) = NewValue
            End If
        Next
    End Sub

    Private Sub ExecButton(ByVal button As CheckBox)
        If RTBLines Is Nothing Then
            Return
        End If
        Dim line As Int32 = RTB.FindLabel(RTBLines, button.Text)
        If line >= 0 Then
            ExecutionThread_Stop()
            If ExistsReturn() Then
                ReturnStack.Push(LineInExecution)
            End If
            GotoLine = line
            ExecutionThread_Start()
            ' ------------------------------ buttons execution while not running
            If Not Running Then
                RTB.ScrollToCenterSelectedLine(line)
                SelectLineLimitedLength(line)
            End If
        End If
        button.Checked = False
    End Sub

    Private Function ExistsReturn() As Boolean
        Dim line As String
        For i As Int32 = 0 To RTBLines.Length - 1
            line = RTBLines(i).Trim.ToLower
            If line.StartsWith("return") Then
                Return True
            End If
        Next
        Return False
    End Function

    Private Sub ExecFlashingButtons()
        For i As Int32 = 0 To NBUTTONS - 1
            If ButtonFlashingFrequency(i) > 0 Then
                ButtonFlashingTimer(i) -= TimerSlow.Interval
                If ButtonFlashingTimer(i) <= 0 Then
                    ButtonFlashingTimer(i) = 1000 / ButtonFlashingFrequency(i)
                    Dim b As CheckBox = GetButtonByIndex(i + 1)
                    If b.BackColor = ButtonFlashingColor1(i) Then
                        b.BackColor = ButtonFlashingColor2(i)
                    Else
                        b.BackColor = ButtonFlashingColor1(i)
                    End If
                    CorrectButtonForeColor(b)
                End If
            End If
        Next
    End Sub

    Private Sub AllFlashingButtonsToFirstColor()
        For i As Int32 = 0 To NBUTTONS - 1
            If ButtonFlashingFrequency(i) > 0 Then
                Dim b As CheckBox = GetButtonByIndex(i + 1)
                b.BackColor = ButtonFlashingColor1(i)
                CorrectButtonForeColor(b)
            End If
        Next
    End Sub

    Private Sub CorrectButtonForeColor(ByVal b As CheckBox)
        If GrayScaleLuminance(b.BackColor) < 145 Then
            b.ForeColor = Color.White
            b.FlatAppearance.MouseOverBackColor = ModifiedColor(b.BackColor, 90)
        Else
            b.ForeColor = Color.Black
            b.FlatAppearance.MouseOverBackColor = ModifiedColor(b.BackColor, -30)
        End If
    End Sub

    Private Sub SetButtonFontSize(ByVal b As CheckBox)
        Dim fontsize As Single = b.Height / 5.0F
        b.Font = New Font("Tahoma", fontsize * 1.6F)
        Dim pixels As Size = TextRenderer.MeasureText(b.Text, b.Font)
        If pixels.Width >= b.Width - 10 Then
            b.Font = New Font("Tahoma", fontsize * 0.95F)
        End If
    End Sub


    ' =============================================================================================
    '   EXECUTION HELPING FUNCTIONS - WITH Invoke from Worker-Thread to UserInterface-Thread
    ' =============================================================================================
    Private Delegate Sub SetButton_Delegate(ByVal nbutton As Int32, ByVal text As String)
    Private Sub SetButton_ThreadSafe(ByVal nbutton As Int32, ByVal text As String)
        If InvokeRequired Then
            Invoke(New SetButton_Delegate(AddressOf SetButton_ThreadSafe), nbutton, text)
        Else
            Dim b As CheckBox
            b = GetButtonByIndex(nbutton)
            If b Is Nothing Then Return
            If text = Nothing Then
                b.Text = Nothing
                SetVisibleButtons()
                Return
            End If
            Select Case text.ToLower
                Case "enabled"
                    b.Enabled = True
                Case "disabled"
                    b.Enabled = False
                Case Else
                    text = text.Replace("""", "")                  
                    b.Text = text
                    SetButtonFontSize(b)
            End Select
            SetVisibleButtons()
        End If
    End Sub

    Private Delegate Sub SetButtonSlot_Delegate(ByVal nbutton As Int32, ByVal slot As Int32)
    Private Sub SetButtonSlot_ThreadSafe(ByVal nbutton As Int32, ByVal slot As Int32)
        If InvokeRequired Then
            Invoke(New SetButtonSlot_Delegate(AddressOf SetButtonSlot_ThreadSafe), nbutton, slot)
        Else
            If nbutton > ButtonSlots.Length Then Return
            ButtonSlots(nbutton - 1) = slot
        End If
    End Sub

    'Private Delegate Sub UncheckButton_Delegate(ByVal button As CheckBox)
    'Private Sub UncheckButton_ThreadSafe(ByVal button As CheckBox)
    '    If InvokeRequired Then
    '        Invoke(New UncheckButton_Delegate(AddressOf UncheckButton_ThreadSafe), button)
    '    Else
    '        button.Checked = False
    '    End If
    'End Sub

    Private Delegate Sub UncheckAllButtons_Delegate()
    Private Sub UncheckAllButtons_ThreadSafe()
        If InvokeRequired Then
            Invoke(New UncheckAllButtons_Delegate(AddressOf UncheckAllButtons_ThreadSafe))
        Else
            UncheckProgrammableButtons()
        End If
    End Sub


    Private Delegate Sub Print_Message_Delegate(ByVal message As String, ByVal TestPrintTextBox As Boolean)
    Private Sub Print_Message_ThreadSafe(ByVal message As String, ByVal TestPrintTextBox As Boolean)
        If InvokeRequired Then
            ' ------------------------------------ wait the command execution with "Invoke" (not "Begin Invoke")
            Invoke(New Print_Message_Delegate(AddressOf Print_Message_ThreadSafe), message, TestPrintTextBox)
        Else
            If TestPrintTextBox AndAlso PrintTextBox.Visible Then
                PrintTextBox.PaintEventEnabled = False
                PrintTextBox.Enabled = False
                If message.StartsWith(Chr(12)) Then
                    message = message.Substring(1)
                    PrintTextBox.Clear()
                End If
                PrintTextBox.Text += message
                PrintTextBox.SelectionStart = PrintTextBox.Text.Length
                PrintTextBox.ScrollToCaret()
                PrintTextBox.Enabled = True
                PrintTextBox.PaintEventEnabled = True
                ' Removed 17 02 2020 
                ' Otherwise the STOP button not works with program "Test COM - SEND RND.txt"
                'PrintTextBox.Focus()
            Else
                SetStatusLabelFontFixed()
                If message.Trim.ToLower.StartsWith("error") Then
                    StatusLabel1.BackColor = Color.FromArgb(255, 160, 150)
                ElseIf message.Trim.ToLower.StartsWith("warning") Then
                    StatusLabel1.BackColor = Color.FromArgb(255, 200, 100)
                Else
                    StatusLabel1.BackColor = Color.FromArgb(220, 255, 200)
                End If
                StatusLabel1.Text = message
                StatusLabel1.Invalidate()
            End If
        End If
    End Sub

    Private Delegate Sub SetNewSpeed_Delegate(ByVal speed As Double)
    Private Sub SetNewSpeed_ThreadSafe(ByVal speed As Double)
        If InvokeRequired Then
            Invoke(New SetNewSpeed_Delegate(AddressOf SetNewSpeed_ThreadSafe), speed)
        Else
            Dim old As Boolean = EventsAreEnabled
            EventsAreEnabled = False
            tkbar_Speed.Value = CInt(speed)
            EventsAreEnabled = old
            SetExecutionDelayParams(CInt(speed))
        End If
    End Sub

    Private Delegate Sub StopRunning_Delegate()
    Private Sub StopRunning_ThreadSafe()
        Running = False
        If InvokeRequired Then
            Invoke(New StopRunning_Delegate(AddressOf StopRunning_ThreadSafe))
        Else
            StopRunning()
        End If
    End Sub

    Private Delegate Sub StopRunning_DontCallLabel_Delegate()
    Private Sub StopRunning_DontCallLabel_ThreadSafe()
        Running = False
        If InvokeRequired Then
            Invoke(New StopRunning_DontCallLabel_Delegate(AddressOf StopRunning_DontCallLabel_ThreadSafe))
        Else
            StopRunning(True, False)
        End If
    End Sub

    'Private Delegate Sub SelectLine_Delegate(ByVal line As Int32)
    'Private Sub SelectLine_ThreadSafe(ByVal line As Int32)
    '    If InvokeRequired Then
    '        Invoke(New SelectLine_Delegate(AddressOf SelectLine_ThreadSafe), line)
    '    Else
    '        Dim old As Boolean = EventsAreEnabled
    '        EventsAreEnabled = False
    '        RTB.SelectLine(line)
    '        EventsAreEnabled = old
    '    End If
    'End Sub

    Private Delegate Sub SelectLineLimitedLength_Delegate(ByVal line As Int32)
    Private Sub SelectLineLimitedLength_ThreadSafe(ByVal line As Int32)
        If InvokeRequired Then
            Invoke(New SelectLineLimitedLength_Delegate(AddressOf SelectLineLimitedLength_ThreadSafe), line)
        Else
            Dim old As Boolean = EventsAreEnabled
            EventsAreEnabled = False
            SelectLineLimitedLength(line)
            EventsAreEnabled = old
        End If
    End Sub

    Private Sub SelectLineLimitedLength(ByVal line As Int32)
        Try
            If line < 0 Then line = 0
            ' ------------------------------------------------- calculate TABS and Zoom (about 10 uS)
            Dim limit As Int32 = CInt(34 / RTB.ZoomFactor) - 4
            Dim s As String = RTBLines(line)
            Dim j As Int32
            Dim i As Int32
            Dim tabs As Boolean = False
            For i = 0 To s.Length - 1
                If s(i) = vbTab Then
                    j += 4 - (j Mod 4)
                    tabs = True
                Else
                    j += 1
                End If
                If j > limit Then Exit For
            Next
            If tabs Then i += 1
            ' ------------------------------------------------- select line (about 1 mS)
            RTB.Select(RTB.GetFirstCharIndexFromLine(line), i)
        Catch
        End Try
    End Sub

    Private Delegate Sub ScrollToCenterSelectedLine_Delegate(ByVal line As Int32)
    Private Sub ScrollToCenterSelectedLine_ThreadSafe(ByVal line As Int32)
        If InvokeRequired Then
            BeginInvoke(New ScrollToCenterSelectedLine_Delegate(AddressOf ScrollToCenterSelectedLine_ThreadSafe), line)
        Else
            Dim old As Boolean = EventsAreEnabled
            EventsAreEnabled = False
            RTB.ScrollToCenterSelectedLine(LineInExecution)
            EventsAreEnabled = old
        End If
    End Sub


    Private Delegate Sub InputDialog_Delegate(ByVal varname As String, ByVal prompt As String)
    Private Sub InputDialog_ThreadSafe(ByVal varname As String, ByVal prompt As String)
        If InvokeRequired Then
            Invoke(New InputDialog_Delegate(AddressOf InputDialog_ThreadSafe), varname, prompt)
        Else
            Form_Input.txt_Input.Text = ""
            Form_Input.Prompt = prompt
            Form_Input.ShowDialog(Me)
            If Form_Input.ValidInput Then
                SetVariable(varname, Form_Input.txt_Input.Text)
            End If
        End If
    End Sub

    Private Delegate Sub Load_Media_Delegate(ByVal filename As String)
    Private Sub Load_Media_ThreadSafe(ByVal filename As String)
        If InvokeRequired Then
            ' ------------------------------------ wait the command execution with "Invoke" (not "BeginInvoke")
            Invoke(New Load_Media_Delegate(AddressOf Load_Media_ThreadSafe), filename)
        Else
            If filename Is Nothing Then filename = "stop"
            '
            ' ---------------------------------------------------- VIDEO and AUDIO POSITION
            If filename.ToLower.Trim.StartsWith("position") Then
                Dim sa() As String = filename.Split(" "c)
                If sa.Length = 2 Then
                    WMP.Ctlcontrols.currentPosition = EvalDouble(sa(1))
                    filename = ""
                End If
            End If
            '
            ' ---------------------------------------------------- PAUSE PLAY STOP HIDE and LOAD-FILE
            Select Case filename.ToLower
                Case "pause" : WMP.Ctlcontrols.pause()
                Case "play" : WMP.Ctlcontrols.play()
                Case "stop" : WMP.URL = "" : WebBrowserStop()
                Case "hide" : PreparePanelsForProgram()
                Case Else
                    Try
                        LoadMediaFile(filename)
                    Catch
                    End Try
            End Select
            ' ------------------------------------- set buttons parent depending on ViewMode and PanelMode
            SetButtonsParent()
        End If
    End Sub

    Private Sub LoadMediaFile(ByVal filename As String)
        Dim fullPath As String
        ' -------------------------------------------------------------------- load txt to variable
        Dim sa() As String = filename.Split(" "c)
        If sa.Length > 1 AndAlso IsStringVariable(sa(0)) Then
            sa(1) = sa(sa.Length - 1)
            sa(1) = sa(1).Replace("""", "")
            If IsStringVariable(sa(1)) Then
                sa(1) = GetStringVariable(sa(1))
            End If
            ' -------------------------------------------------------- try near to program file
            fullPath = IO.Path.GetDirectoryName(ProgramFile_PathAndName) + "\" + sa(1)
            ' -------------------------------------------------------- else try the "Files" folder
            If Not My.Computer.FileSystem.FileExists(fullPath) Then
                fullPath = PlatformAdjustedFileName(Application.StartupPath + "\Files\" + sa(1))
            End If
            If My.Computer.FileSystem.FileExists(fullPath) Then
                SetVariable(sa(0), IO.File.ReadAllText(fullPath))
            Else
                SetVariable(sa(0), "")
            End If
            Return
        End If
        ' -------------------------------------------------------------------- normal media load
        filename = EvalString_AutoQuoting(filename)
        '
        If filename.StartsWith("http", StringComparison.InvariantCultureIgnoreCase) Then
            WebBrowserStart(filename)
        Else
            Select Case Strings.Right(filename, 4).ToLower
                Case ".txt"
                    fullPath = PlatformAdjustedFileName(Application.StartupPath & "\Programs\" & filename)
                    If My.Computer.FileSystem.FileExists(fullPath) Then
                        ExecutionThread_Stop()
                        Load_Program(fullPath)
                        RTBLines = RTB.Lines
                        GotoLine = 0
                        ExecutionThread_Start()
                    End If
                    ExecutionDelay_Variable()
                Case ".jpg", ".bmp", ".png"
                    GBox_Program.Text = filename
                    fullPath = PlatformAdjustedFileName(Application.StartupPath & "\Media\" & filename)
                    If My.Computer.FileSystem.FileExists(fullPath) Then
                        PictureBox1.Image = Image.FromFile(fullPath)
                        PreparePanelsForImages()
                        GBox_Program.Text = filename
                    End If
                Case ".avi", ".wmv", ".mpg", ".mp4", ".mov", ".gif"
                    GBox_Program.Text = "Loading """ + filename + """   >>> PLEASE WAIT SOME SECONDS <<<"
                    fullPath = PlatformAdjustedFileName(Application.StartupPath & "\Media\" & filename)
                    If My.Computer.FileSystem.FileExists(fullPath) Then
                        WMP.URL = fullPath
                        WMP_WaitReady()
                        PreparePanelsForVideo()
                        GBox_Program.Text = filename
                    End If
                Case ".mp3", ".wav"
                    'GBox_Program.Text = filename ' not showing name because not visible
                    fullPath = PlatformAdjustedFileName(Application.StartupPath & "\Media\" & filename)
                    If My.Computer.FileSystem.FileExists(fullPath) Then
                        WMP.Hide()
                        WMP.URL = fullPath
                        WMP_WaitReady()
                        'GBox_Program.Text = filename ' not showing name because not visible
                    End If
                Case ".exe"
                    StartProcess_IfNotRunning_AndWait(filename)
                    Me.Activate()
            End Select
        End If
    End Sub



    ' =============================================================================================
    '   EXECUTION HELPING FUNCTIONS - Directly executed in the Worker-Thread
    ' =============================================================================================

    ' TODO - EVENT TIMER 2
    ' ----------------------------------------------------------------
    '  ExecutionDelayVariable_WaitSeconds
    ' ----------------------------------------------------------------
    Private EDV_WaitSecondsStopWatch As Stopwatch = New Stopwatch
    Private EDV_ResetStopWatchEnabled As Boolean = True
    Private Sub ExecutionDelayVariable_WaitSeconds(ByVal seconds As Double)
        If EDV_ResetStopWatchEnabled Then
            EDV_WaitSecondsStopWatch.Reset()
            EDV_WaitSecondsStopWatch.Start()
        End If
        EDV_ResetStopWatchEnabled = True
        Do
            If EventTimer_Exec() Then
                EDV_ResetStopWatchEnabled = False
                Exit Do
            End If
            Thread.Sleep(1)
        Loop Until EDV_WaitSecondsStopWatch.Elapsed.TotalSeconds >= seconds OrElse TerminateThread = True OrElse Running = False
    End Sub

    ' TODO - EVENT TIMER 2b
    ' ----------------------------------------------------------------
    '  WaitSeconds
    ' ----------------------------------------------------------------
    Private WaitSecondsStopWatch As Stopwatch = New Stopwatch
    Private ResetStopWatchEnabled As Boolean = True
    Private Sub Wait_Seconds(ByVal seconds As Double)
        If ResetStopWatchEnabled Then
            WaitSecondsStopWatch.Reset()
            WaitSecondsStopWatch.Start()
        End If
        ResetStopWatchEnabled = True
        Do
            If EventTimer_Exec() Then
                ResetStopWatchEnabled = False
                Exit Do
            End If
            Thread.Sleep(1)
        Loop Until WaitSecondsStopWatch.Elapsed.TotalSeconds >= seconds OrElse TerminateThread = True OrElse Running = False
    End Sub

    ' ----------------------------------------------------------------
    '  Wait_Forever
    ' ----------------------------------------------------------------
    Sub Wait_Forever()
        Do
            If EventTimer_Exec() Then Exit Do
            Thread.Sleep(1)
        Loop Until TerminateThread = True OrElse Running = False
    End Sub

    ' ----------------------------------------------------------------
    '  Wait_Button
    ' ----------------------------------------------------------------
    Sub Wait_Button(ByVal ButtonName As String)
        Thread.Sleep(50)
        Dim button As CheckBox = Nothing
        Dim b As CheckBox
        ButtonName = ButtonName.ToLower
        ' --------------------------------------------------- test name
        For i As Int32 = 1 To NBUTTONS
            b = GetButtonByIndex(i)
            If b.Text.ToLower = ButtonName Then
                button = b
                Exit For
            End If
        Next
        ' --------------------------------------------------- test first word of name
        If button Is Nothing Then
            ButtonName = RTB.ExtractFirstWord(ButtonName)
            For i As Int32 = 1 To NBUTTONS
                b = GetButtonByIndex(i)
                If RTB.ExtractFirstWord(b.Text).ToLower = ButtonName Then
                    button = b
                    Exit For
                End If
            Next
        End If
        ' --------------------------------------------------- wait the button release
        If button IsNot Nothing Then
            Do
                If EventTimer_Exec() Then Exit Do
                Thread.Sleep(5)
            Loop Until button.Checked Or Running = False
            UncheckAllButtons_ThreadSafe()
        End If
    End Sub

    Sub Wait_Process(ByVal ProcessName As String)
        Do
            If EventTimer_Exec() Then Exit Do
            Thread.Sleep(5)
        Loop Until Not AppIsRunning(ProcessName) OrElse TerminateThread = True OrElse Running = False
    End Sub

    Friend Sub Beep_RepetitionLimited(ByVal ms As Int32)
        Static sw As Stopwatch
        If sw Is Nothing Then
            sw = New Stopwatch
        Else
            If sw.ElapsedMilliseconds < ms Then Return
        End If
        sw.Reset()
        sw.Start()
        Beep()
    End Sub

    Private Function FindElseOrEndif() As Int32
        Dim counter As Int32 = 0
        Dim line As String
        For i As Int32 = LineInExecution + 1 To RTBLines.Length - 1
            line = RTBLines(i).Trim.ToLower
            If line.StartsWith("else") Then
                If counter = 0 Then  ' changed from "<=" to "=" since version 3.6
                    Return i
                End If
            ElseIf line.StartsWith("endif") Then
                If counter = 0 Then  ' changed from "<=" to "=" since version 3.6
                    Return i
                End If
                counter -= 1
            ElseIf line.StartsWith("if") Then
                counter += 1
            End If
        Next
        Return -1
    End Function

    Private Function FindEndif() As Int32
        Dim counter As Int32 = 0
        Dim line As String
        For i As Int32 = LineInExecution + 1 To RTBLines.Length - 1
            line = RTBLines(i).Trim.ToLower
            If line.StartsWith("endif") Then
                If counter = 0 Then  ' changed from "<=" to "=" since version 3.6
                    Return i
                End If
                counter -= 1
            ElseIf line.StartsWith("if") Then
                counter += 1
            End If
        Next
        Return -1
    End Function

    Private Function FindCaseNumeric(ByVal d As Double) As Int32
        Dim counter As Int32 = 0
        Dim line As String
        For i As Int32 = LineInExecution + 1 To RTBLines.Length - 1
            line = RTBLines(i).Trim.ToLower
            If line.StartsWith("case") Then
                If counter = 0 Then
                    ' ----------------------------------------------------------- Tokenize to array of keywords
                    Dim l() As String = RTB.Tokenize(RTBLines(i).Trim)
                    If l.Length > 1 AndAlso d = EvalDouble(l(1)) Then
                        Return i
                    End If
                End If
            ElseIf line.StartsWith("endselect") Then
                counter -= 1
            ElseIf line.StartsWith("select") Then
                counter += 1
            End If
        Next
        Return -1
    End Function

    Private Function FindCaseString(ByVal s As String) As Int32
        Dim counter As Int32 = 0
        Dim line As String
        For i As Int32 = LineInExecution + 1 To RTBLines.Length - 1
            line = RTBLines(i).Trim.ToLower
            If line.StartsWith("case") Then
                If counter = 0 Then
                    ' ----------------------------------------------------------- Tokenize to array of keywords
                    Dim l() As String = RTB.Tokenize(RTBLines(i).Trim)
                    If l.Length > 1 AndAlso s = EvalString(l(1)) Then
                        Return i
                    End If
                End If
            ElseIf line.StartsWith("endselect") Then
                counter -= 1
            ElseIf line.StartsWith("select") Then
                counter += 1
            End If
        Next
        Return -1
    End Function

    Private Function FindCaseElse() As Int32
        Dim counter As Int32 = 0
        Dim line As String
        For i As Int32 = LineInExecution + 1 To RTBLines.Length - 1
            line = RTBLines(i).Trim.ToLower
            If line = "caseelse" Then
                If counter = 0 Then
                    Return i
                End If
                counter -= 1
            ElseIf line.StartsWith("select") Then
                counter += 1
            End If
        Next
        Return -1
    End Function

    Private Function FindEndselect() As Int32
        Dim counter As Int32 = 0
        Dim line As String
        For i As Int32 = LineInExecution + 1 To RTBLines.Length - 1
            line = RTBLines(i).Trim.ToLower
            If line.StartsWith("endselect") Then
                If counter = 0 Then
                    Return i
                End If
                counter -= 1
            ElseIf line.StartsWith("select") Then
                counter += 1
            End If
        Next
        Return -1
    End Function

    Private Function FindNext() As Int32
        Dim counter As Int32 = 0
        Dim line As String
        For i As Int32 = LineInExecution + 1 To RTBLines.Length - 1
            line = RTBLines(i).Trim.ToLower
            If line.StartsWith("next") Then
                If counter = 0 Then
                    Return i
                End If
                counter -= 1
            ElseIf line.StartsWith("for") Then
                counter += 1
            End If
        Next
        Return -1
    End Function


    ' =============================================================================================
    '  Keyboard Keys Events
    ' =============================================================================================
    Private Structure KeyEvent
        Public KeyCode As Keys
        Public IsGosub As Boolean
        Public LabelText As String
    End Structure
    Private KeyEvents(-1) As KeyEvent
    Private Sub ClearKeyEvents()
        ReDim KeyEvents(-1)
        KeyEventsStackIndex = 99999
    End Sub
    Private Sub SetKeyEvent(ByVal s1 As String, ByVal s2 As String, ByVal s3 As String)
        Dim k As Keys = GetKeyCode(s1)
        Dim ix As Int32 = -1
        ' -------------------------------------------- test if KeyCode already exists
        For i As Int32 = 0 To KeyEvents.Length - 1
            If k = KeyEvents(i).KeyCode Then
                ix = i
            End If
        Next
        ' -------------------------------------------- if not exists create a new place
        If ix < 0 Then
            ix = KeyEvents.Length
            ReDim Preserve KeyEvents(ix)
        End If
        ' -------------------------------------------- add the new KeyEvent
        With KeyEvents(ix)
            .KeyCode = k
            .IsGosub = s2.ToLower = "gosub"
            .LabelText = s3.ToLower
        End With
    End Sub

    Private KeyEventsStackIndex As Int32
    Private Sub ExecKeysEvent(ByVal keycode As Keys)
        ' ------------------------------------------------------ do not accumulate stacked keys
        If KeyEventsStackIndex < ReturnStack.Count Then Return
        KeyEventsStackIndex = ReturnStack.Count
        ' ------------------------------------------------------ FLUSH UNUSED
        'SendKeys.Flush()
        ' ------------------------------------------------------ exec the key
        For Each k As KeyEvent In KeyEvents
            If keycode = k.KeyCode Then
                Dim line As Int32 = RTB.FindLabel(RTBLines, k.LabelText)
                If line >= 0 Then
                    ExecutionThread_Stop()
                    If k.IsGosub And ExistsReturn() Then
                        ReturnStack.Push(LineInExecution)
                        'Debug_Print(" ReturnStack.Push " + _
                        '            "  Line=" + LineInExecution.ToString + _
                        '            "  StackPeek=" + ReturnStack.Peek.ToString + _
                        '            "  StackCount=" + ReturnStack.Count.ToString)
                    End If
                    GotoLine = line
                    ExecutionThread_Start()
                End If
                Return
            End If
        Next
    End Sub

    ' =============================================================================================
    '  EXECUTION DELAY
    ' =============================================================================================
    Private InstructionsCounter As Int32 = 0
    Private InstructionsCounterMax As Int32
    Private ExecutionDelayMillisec As Int32
    Private Sub SetExecutionDelayParams(ByVal n As Int32)
        If n = 0 Then n = tkbar_Speed.Value
        If n > 9 Then n = 9
        Select Case n
            Case 1 : ExecutionDelayMillisec = 1000 : InstructionsCounterMax = 0
            Case 2 : ExecutionDelayMillisec = 500 : InstructionsCounterMax = 0
            Case 3 : ExecutionDelayMillisec = 200 : InstructionsCounterMax = 0
            Case 4 : ExecutionDelayMillisec = 100 : InstructionsCounterMax = 0
            Case 5 : ExecutionDelayMillisec = 50 : InstructionsCounterMax = 0
            Case 6 : ExecutionDelayMillisec = 10 : InstructionsCounterMax = 0
            Case 7 : ExecutionDelayMillisec = 1 : InstructionsCounterMax = 0
            Case 8 : ExecutionDelayMillisec = 1 : InstructionsCounterMax = 10
            Case 9 : ExecutionDelayMillisec = 1 : InstructionsCounterMax = 100
        End Select
    End Sub
    Private Sub ShowExecutionDelayText(ByVal n As Int32)
        Dim s As String = ""
        Select Case n
            Case 1 : s = "1 instructions per second - CPU usage very low"
            Case 2 : s = "2 instructions per second - CPU usage very low"
            Case 3 : s = "5 instructions per second - CPU usage very low"
            Case 4 : s = "10 instructions per second - CPU usage very low"
            Case 5 : s = "20 instructions per second - CPU usage very low"
            Case 6 : s = "100 instructions per second - CPU usage very low"
            Case 7 : s = "1000 instructions per second - 1 mS each instruction - CPU usage low"
            Case 8 : s = "10 000 instructions per second - 100 uS each instruction - CPU usage about 2%"
            Case 9 : s = "100 000 instructions per second - 10 uS each instruction (if possible) - High CPU usage"
        End Select
        SetStatusLabelFontProportional()
        StatusLabel1.Text = s
    End Sub
    Private Sub ExecutionDelay_Variable()
        ' TODO - EVENT TIMER 3
        If EventTimer_Working Then Return
        If SingleStep Then Return
        InstructionsCounter += 1
        If InstructionsCounter >= InstructionsCounterMax Then
            InstructionsCounter = 0
            ExecutionDelayVariable_WaitSeconds(ExecutionDelayMillisec / 1000)
        End If
    End Sub
    Private Sub ExecutionDelay_Minimum()
        InstructionsCounter += 1
        If InstructionsCounter >= InstructionsCounterMax Then
            InstructionsCounter = 0
            Thread.Sleep(1)
        End If
    End Sub


    ' =============================================================================================
    '   TIMERS
    ' =============================================================================================
    Private Sub TimerSlow_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TimerSlow.Tick
        If Running Then
            ExecButtonsFromSlots()
            ExecFlashingButtons()
        Else
            chk_ControlsBack.Enabled = RTB.Editor_CanHistoryBack
            chk_ControlsForward.Enabled = RTB.Editor_CanHistoryForward
            chk_ControlsUndo.Enabled = RTB.Editor_CanUndo
            chk_ControlsRedo.Enabled = RTB.Editor_CanRedo
        End If
    End Sub

    Private BlueLineOld As Int32 = -1
    Private Sub Timer_Fast_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TimerFast.Tick
        If Running Or BlueLineOld < 0 Then
            ' --------------------------------- Select all the line (if not changing line the time about 0.002 mS)
            If LineInExecution <> BlueLineOld Then
                BlueLineOld = LineInExecution
                ' ----------------------------- Scroll only if the Speed is less than 5
                If tkbar_Speed.Value < 5 Then
                    RTB.ScrollToCenterSelectedLine(LineInExecution)
                End If
                ' ----------------------------- Select the first part (no horizzontal scroll)
                SelectLineLimitedLength(LineInExecution)
            End If
        End If

        ' ------------------------------------- Flickering booster (to test ListViewFlickerFree)
        'If My.Computer.Keyboard.CapsLock Then
        '    Form_Debug.ListView1.BeginUpdate()
        '    Form_Debug.ListView1.EndUpdate()
        'End If
        ' -------------------------------------------------------------------------------------

        'Text = GetNormalizedCursorX.ToString("0.0", GCI) + "  " + GetNormalizedCursorY.ToString("0.0", GCI)
    End Sub


    ' TODO - EVENT TIMER 1

    ' ===========================================================================================
    '   EVENT TIMER
    ' ===========================================================================================

    Private EventTimer_LockObj As Object = New Object
    Friend EventTimer_StartLine As Int32
    Friend EventTimer_EndLine As Int32
    Private EventTimer_Working As Boolean
    Private EventTimer_StopWatch As Stopwatch = New Stopwatch
    Friend Sub EventTimer_Init()
        Dim n As Int32 = RTB.FindLabel(RTBLines, "EventTimer")
        If n >= 0 And n < RTBLines.Length Then
            EventTimer_StartLine = n
            For n = n + 1 To RTBLines.Length - 1
                Dim l As String = RTBLines(n).Trim.ToLower
                If l.StartsWith("return") Then
                    EventTimer_EndLine = n
                    EventTimer_StopWatch.Reset()
                    EventTimer_StopWatch.Start()
                    EventTimer_Working = False
                    Return
                End If
                If l.StartsWith("label") Then
                    Exit For
                End If
            Next
        End If
        EventTimer_StartLine = -1
        EventTimer_EndLine = -1
        EventTimer_StopWatch.Stop()
        EventTimer_StopWatch.Reset()
        EventTimer_Working = False
    End Sub

    Private Function EventTimer_Exec() As Boolean
        If EventTimer_StartLine < 0 Then Return False
        If EventTimer_StopWatch.ElapsedMilliseconds < 100 Then Return False

        SyncLock EventTimer_LockObj
            'If EventTimer_Working Then Return False
            EventTimer_Working = True
            ReturnStack.Push(LineInExecution) ' + 1)
            GotoLine = EventTimer_StartLine
            LineInExecution = EventTimer_StartLine
            EventTimer_Exec = True
            Thread.Sleep(1)
            EventTimer_StopWatch.Reset()
            EventTimer_StopWatch.Start()
        End SyncLock
    End Function


    ' =============================================================================================
    '   EXECUTION THREAD
    ' =============================================================================================
    Friend Running As Boolean
    Friend Debugging As Boolean
    Friend TerminateThread As Boolean
    Private ExecutionThread As Thread
    Sub ExecutionThread_Start()
        If ExecutionThread IsNot Nothing Then Return
        ExecutionThread = New Thread(AddressOf MainExecutionThread)
        ExecutionThread.Priority = System.Threading.ThreadPriority.AboveNormal
        TerminateThread = False
        ExecutionThread.Start()
    End Sub
    Sub ExecutionThread_Stop()
        If ExecutionThread Is Nothing Then Return
        ' --------------------------------------------- try to join the thread for 500 mS
        TerminateThread = True
        ExecutionThread.Join(500)
        ' --------------------------------------------- if not joined then abort it
        If ExecutionThread.IsAlive Then
            ExecutionThread.Abort()
        End If
        ' ---------------------------------------------
        ExecutionThread = Nothing
    End Sub
    Sub MainExecutionThread()
        If RTBLines Is Nothing Then Return
        If RTBLines.Length = 0 Then Return
        Do
            RTB_Exec()
        Loop Until TerminateThread
        TerminateThread = False
    End Sub


    ' =============================================================================================
    '  EXECUTION
    ' =============================================================================================
    Friend PauseButtonSlot As Int32 = -1
    Private SingleStep As Boolean
    Private GotoLine As Int32 = -1
    Private LineInExecution As Int32 = -1
    Private LineBeforeRun As Int32 = -1
    Private ReturnStack As Stack(Of Integer) = New Stack(Of Integer)
    Private ForNextStack As Stack(Of Integer) = New Stack(Of Integer)
    Private JumpingFromNEXT As Boolean = False
    Private JumpingFromNext_LineIndex As Int32
    'Private sw As Stopwatch = New Stopwatch ' speed tester

    Friend Sub RTB_Exec()
        '
        If Not Running Then Thread.Sleep(1) : Return
        '
        ' ----------------------------------------------------------------- GOTO LINE
        If GotoLine >= 0 Then
            LineInExecution = GotoLine
            GotoLine = -1
            SkipEmptyLines(LineInExecution)
        Else
            If LineInExecution > RTBLines.Length - 1 Then
                LineInExecution = 0
            End If
            ' ------------------------------------------------------------- TEST FOR BREAKPOINT
            If Debugging Then
                If RTBLines(LineInExecution).ToLower.Contains("breakpoint") Then
                    LineBeforeRun = -1
                    ScrollToCenterSelectedLine_ThreadSafe(LineInExecution)
                    SelectLineLimitedLength_ThreadSafe(LineInExecution)
                    StopRunning_DontCallLabel_ThreadSafe()
                    Exit Sub
                End If
            End If
        End If
        '
        ' ----------------------------------------------------------------- EXEC THE LINE
        ExecTheLine(LineInExecution)

        ' ----------------------------------------------------------------- do not increment the line
        If TerminateThread Then Return
        '
        ' ----------------------------------------------------------------- NEXT LINE
        LineInExecution += 1
        SkipEmptyLines(LineInExecution)

        ' ----------------------------------------------------------------- TEST FOR BREAKPOINT (patch for return)
        '  This is a patch to test breakpoint after a return from gosub
        If Debugging Then
            If RTBLines(LineInExecution).ToLower.Contains("breakpoint") Then
                LineBeforeRun = -1
                ScrollToCenterSelectedLine_ThreadSafe(LineInExecution)
                SelectLineLimitedLength_ThreadSafe(LineInExecution)
                StopRunning_DontCallLabel_ThreadSafe()
                Exit Sub
            End If
        End If
        '
        ' ----------------------------------------------------------------- SINGLE STEP
        If SingleStep Then
            SingleStep = False
            Exit Sub
        End If
        '
        ' ----------------------------------------------------------------- TEST THE PAUSE BUTTON
        If PauseButtonSlot > 0 Then
            If Slots.ReadSlot(PauseButtonSlot) >= 500 Then
                Print_Message_ThreadSafe(" WARNING : Pause button is pressed (verify the Slot " + PauseButtonSlot.ToString + ")", False)
                Do
                    Thread.Sleep(10)
                    If Slots.ReadSlot(PauseButtonSlot) < 500 Then
                        Print_Message_ThreadSafe("", False)
                        Exit Do
                    End If
                Loop
            End If
        End If
        '
        ' ----------------------------------------------------------------- WAIT THE EXECUTION DELAY
        ExecutionDelay_Variable()
        '
        ' ----------------------------------------------------------------- speed tester
        'Print_Message_ThreadSafe(sw.Elapsed.TotalMilliseconds.ToString)
        'sw.Reset()
        'sw.Start()
    End Sub

    Private Sub SkipEmptyLines(ByRef i As Int32)
        For j As Int32 = 0 To RTBLines.Length - 1
            If Not LineIsEmptyOrComment(i) Then Exit For
            i += 1
            If i > RTBLines.Length - 1 Then i = 0
        Next
    End Sub

    Private Function LineIsEmptyOrComment(ByVal index As Int32) As Boolean
        If index < 0 Then Return True
        If index >= RTBLines.Length Then Return True
        Dim l As String = RTBLines(index).Trim
        If l = "" Then Return True
        If l.StartsWith("'") AndAlso Not l.ToLower.Contains("breakpoint") Then Return True
        Return False
    End Function


    ' =============================================================================================
    '  EXEC THE LINE
    ' =============================================================================================
    Friend Sub ExecTheLine(ByVal PC As Int32, Optional ByVal line As String = "")
        ' ----------------------------------------------------------------- Tokenize to array of keywords
        Dim sa() As String
        If line <> "" Then
            sa = RTB.Tokenize(line.Trim)
        Else
            sa = RTB.Tokenize(RTBLines(PC).Trim)
        End If
        ' ----------------------------------------------------------------- if empty line return
        If sa.Length = 0 Then ExecutionDelay_Minimum() : Return
        '
        Select Case sa.Length
            Case 1
                Select Case sa(0).ToLower
                    Case "beep"
                        Beep_RepetitionLimited(100)
                    Case "else"
                        Dim n As Int32 = FindEndif()
                        If n >= 0 And n < RTBLines.Length Then
                            GotoLine = n
                            LineInExecution = n - 1
                        End If
                    Case "caseelse"
                        Dim n As Int32 = FindEndselect()
                        If n >= 0 And n < RTBLines.Length Then
                            GotoLine = n
                            LineInExecution = n
                        End If
                    Case "exit"
                        Dim n As Int32 = FindNext()
                        If n >= 0 And n < RTBLines.Length Then
                            GotoLine = n + 1
                            LineInExecution = n
                            ForNextStack.Pop()
                        End If
                    Case "return"
                        If ReturnStack.Count > 0 Then
                            Dim n As Int32 = ReturnStack.Pop
                            If n >= 0 And n < RTBLines.Length Then
                                GotoLine = n
                                LineInExecution = n - 1
                            End If
                            If EventTimer_Working Then
                                EventTimer_Working = False
                            End If
                        Else
                            ' ------------------------------------- if can not RETURN then
                            If SingleStep Then
                                LineInExecution -= 1
                            Else
                                If EventStopLabelExecuted Then
                                    ' ----------------------------- exec a STOP
                                    StopRunning_ThreadSafe()
                                    LineInExecution -= 1
                                Else
                                    ' ----------------------------- or wait forever
                                    Wait_Forever()
                                End If
                            End If
                        End If
                    Case "next"
                        If ForNextStack.Count > 0 Then
                            Dim n As Int32 = ForNextStack.Peek
                            If n >= 0 And n < RTBLines.Length Then
                                JumpingFromNEXT = True
                                JumpingFromNext_LineIndex = LineInExecution
                                GotoLine = n
                                LineInExecution = n - 1
                            End If
                        End If
                    Case "stop"
                        If SingleStep Then
                            LineInExecution -= 1
                        Else
                            Wait_Forever()
                        End If
                    Case "end"
                        StopRunning_DontCallLabel_ThreadSafe()
                        LineInExecution -= 1
                End Select
            Case 2
                Select Case sa(0).ToLower
                    Case "com"
                        If sa(1).ToLower = "close" Then
                            COM_Close()
                        ElseIf sa(1).ToLower = "discardinbuffer" Then
                            COM_DiscardInBuffer()
                        ElseIf sa(1).ToLower = "discardoutbuffer" Then
                            COM_DiscardOutBuffer()
                        ElseIf sa(1).ToLower = "enabledtr" Then
                            COM_EnableDTR()
                        ElseIf sa(1).ToLower = "enablerts" Then
                            COM_EnableRTS()
                        ElseIf sa(1).ToLower = "disabledtr" Then
                            COM_DisableDTR()
                        ElseIf sa(1).ToLower = "disablerts" Then
                            COM_DisableRTS()
                        End If
                    Case "controls"
                        If sa(1).ToLower = "opentextbox" Then
                            SetTextBox_ThreadSafe("Open")
                        ElseIf sa(1).ToLower = "closetextbox" Then
                            SetTextBox_ThreadSafe("Close")
                        ElseIf sa(1).ToLower = "cleartextbox" Then
                            SetTextBox_ThreadSafe("Clear")
                        End If
                    Case "gosub"
                        Dim n As Int32 = RTB.FindLabel(RTBLines, sa(1))
                        If n >= 0 And n < RTBLines.Length Then
                            ReturnStack.Push(PC + 1)
                            GotoLine = n
                            LineInExecution = n
                        End If
                    Case "goto"
                        Dim n As Int32 = RTB.FindLabel(RTBLines, sa(1))
                        If n >= 0 And n < RTBLines.Length Then
                            GotoLine = n
                            LineInExecution = n
                            TrimTheForNextStack(PC, n)
                        End If
                    Case "if"
                        If Not EvalBoolean(sa(1)) Then
                            Dim n As Int32 = FindElseOrEndif()
                            If n >= 0 And n < RTBLines.Length Then
                                GotoLine = n + 1
                                LineInExecution = n
                            End If
                        End If
                    Case "select"
                        Dim n As Int32
                        ' ------------------------------------------
                        If IsNumeric(sa(1)) Then
                            Dim d As Double = EvalDouble(sa(1))
                            n = FindCaseNumeric(d)
                        Else
                            Dim s As String = EvalString(sa(1))
                            n = FindCaseString(s)
                        End If
                        ' ------------------------------------------
                        If n >= 0 And n < RTBLines.Length Then
                            GotoLine = n + 1
                            LineInExecution = n
                        Else
                            n = FindCaseElse()
                            If n >= 0 And n < RTBLines.Length Then
                                GotoLine = n + 1
                                LineInExecution = n
                            Else
                                n = FindEndselect()
                                If n >= 0 And n < RTBLines.Length Then
                                    GotoLine = n
                                    LineInExecution = n
                                End If
                            End If
                        End If
                    Case "case"
                        Dim n As Int32 = FindEndselect()
                        If n >= 0 And n < RTBLines.Length Then
                            GotoLine = n
                            LineInExecution = n
                        End If
                    Case "load"
                        If sa(1).ToLower.Trim.StartsWith("slots") Then
                            Dim n() As Double = ExtractNumericParams(sa(1), 3)
                            If n.Length = 2 Then
                                If n(0) < 0 Then n(0) = 0
                                If n(0) > 999 Then n(0) = 999
                                If n(1) < 0 Then n(1) = 0
                                If n(1) > 999 Then n(1) = 999
                                LoadSlots(CInt(n(0)), CInt(n(1)))
                            Else
                                LoadSlots(0, 999)
                            End If
                        Else
                            Select Case sa(1).ToLower.Trim
                                Case "vars"
                                    LoadVars()
                                Case "closeapps"
                                    CloseAllThereminoApps()
                                    Me.Close()
                                Case Else
                                    Load_Media_ThreadSafe(sa(1).Trim)
                            End Select
                        End If
                    Case "presskeys"
                        ExecutePressKeys(EvalString_AutoQuoting(sa(1)))
                    Case "sendkeys"
                        ExecuteSendKeys(EvalString_AutoQuoting(sa(1)))
                    Case "print"
                        Print_Message_ThreadSafe(EvalString(sa(1)), True)
                    Case "save"
                        Select Case sa(1).ToLower
                            Case "slots"
                                SaveSlots()
                            Case "vars"
                                SaveVars()
                        End Select
                    Case "speed"
                        SetNewSpeed_ThreadSafe(EvalDouble(sa(1)))
                    Case "wait"
                        If Not SingleStep Then
                            If IsValidBoolean(sa(1)) Then
                                Do
                                    If EventTimer_Exec() Then Exit Do
                                    Thread.Sleep(10)
                                Loop Until EvalBoolean(sa(1))
                            End If
                        End If
                    Case "window"
                        Select Case sa(1).ToLower
                            Case "minsize"
                                SetViewMode_ThreadSafe(ViewModes.MinSize)
                            Case "sizable"
                                SetViewMode_ThreadSafe(ViewModes.Sizable)
                            Case "maximized"
                                SetViewMode_ThreadSafe(ViewModes.Maximized)
                            Case "fullscreen"
                                SetViewMode_ThreadSafe(ViewModes.FullScreen)
                        End Select
                End Select
            Case 3
                Select Case sa(0).ToLower
                    Case "com"
                        If sa(1).ToLower = "writestring" Then
                            COM_WriteString(EvalString_AutoQuoting(sa(2)))
                        ElseIf sa(1).ToLower = "writeline" Then
                            COM_WriteLine(EvalString_AutoQuoting(sa(2)))
                        End If
                    Case "save"
                        If sa(1).ToLower = "deletefile" Then
                            Dim s As String = EvalString_AutoQuoting(sa(2))
                            s = Application.StartupPath + "\Files\" + s
                            If IO.File.Exists(s) Then
                                IO.File.Delete(s)
                            End If
                        End If
                    Case "wait"
                        If Not SingleStep Then
                            ' TODO - EVENT TIMER 4
                            If sa(1).ToLower = "seconds" Then Wait_Seconds(EvalDouble(sa(2)))
                            If sa(1).ToLower = "button" Then Wait_Button(sa(2))
                            If sa(1).ToLower = "application" Then Wait_Process(EvalString(sa(2)))
                        End If
                    Case Else
                        If sa(1) = "=" Then
                            If IsNumericUserVariable(sa(0)) Then SetNumericUserVariable(sa(0), EvalDouble(sa(2)))
                            If IsStringUserVariable(sa(0)) Then SetStringUserVariable(sa(0), EvalString(sa(2)))
                            If IsNumericShortVariable(sa(0)) Then SetNumericShortVar(sa(0), EvalDouble(sa(2)))
                            If IsStringShortVariable(sa(0)) Then SetStringShortVar(sa(0), EvalString(sa(2)))
                        End If
                End Select
            Case 4
                Select Case sa(0).ToLower
                    Case "button"
                        If sa(2).ToLower = "slot" Then SetButtonSlot_ThreadSafe(Val_Int(sa(1)), Val_Int(sa(3)))
                        If sa(2).ToLower = "text" Then
                            SetButton_ThreadSafe(CInt(EvalDouble(sa(1))), sa(3))
                            ' this sleep avoids app. locking with only "Button" lines and no "Stop" and Speed=9
                            Thread.Sleep(1)
                        End If
                        ' --------------------------------------------------------------------------
                        If sa(2).ToLower = "color" Then
                            Dim buttonIndex As Int32 = CInt(EvalDouble(sa(1)))
                            Dim btn As CheckBox = GetButtonByIndex(buttonIndex)
                            If btn Is Nothing Then
                                buttonIndex = CInt(GetNumericVariable(sa(1)))
                                btn = GetButtonByIndex(buttonIndex)
                            End If
                            If btn IsNot Nothing Then
                                If sa(3).Length > 8 And sa(3).ToLower.StartsWith("flashing") Then
                                    ' ------------------------------------------------------------------ Flashing
                                    Dim freq As Single = CSng(Val(sa(3).Substring(8, 1)))
                                    Select Case freq
                                        Case 0 : freq = 4
                                        Case 1 : freq = 1
                                        Case 2 : freq = 1.5
                                        Case 3 : freq = 2
                                        Case 4 : freq = 3
                                        Case 5 : freq = 4.5
                                        Case 6 : freq = 6.5
                                        Case 7 : freq = 9
                                        Case 8 : freq = 13.5
                                        Case 9 : freq = 20
                                    End Select
                                    ButtonFlashingFrequency(buttonIndex - 1) = freq
                                    ButtonFlashingTimer(buttonIndex - 1) = 0
                                    '
                                    Dim sa2() As String = ReplaceMultipleSpacesAndTabAndTrim(sa(3)).Split(" "c)
                                    If sa2.Length = 3 Then
                                        ButtonFlashingColor1(buttonIndex - 1) = ColorFromColorName(sa2(1))
                                        ButtonFlashingColor2(buttonIndex - 1) = ColorFromColorName(sa2(2))
                                        btn.BackColor = ButtonFlashingColor2(buttonIndex)
                                    ElseIf sa2.Length = 7 Then
                                        ButtonFlashingColor1(buttonIndex - 1) = ColorFromColorName(sa2(1) + " " + sa2(2) + " " + sa2(3))
                                        ButtonFlashingColor2(buttonIndex - 1) = ColorFromColorName(sa2(4) + " " + sa2(5) + " " + sa2(6))
                                        btn.BackColor = ButtonFlashingColor2(buttonIndex)
                                    Else
                                        ButtonFlashingFrequency(buttonIndex - 1) = 0
                                    End If
                                Else
                                    ' ------------------------------------------------------------------ Not flashing
                                    Dim c As Color = ColorFromColorName(sa(3))
                                    If c <> Color.Empty Then
                                        btn.BackColor = c
                                        CorrectButtonForeColor(btn)
                                        ButtonFlashingFrequency(buttonIndex - 1) = 0
                                    End If
                                    'SetButton_ThreadSafe(CInt(EvalDouble(sa(1))), sa(3))
                                End If
                            End If
                        End If
                    Case "com"
                        If sa(1).ToLower = "open" Then
                            COM_Open("COM" + EvalDouble(sa(2)).ToString, CInt(EvalDouble(sa(3))))
                        End If
                    Case "key"
                        If RTB.IsValidKey(sa(1).ToLower) Then
                            SetKeyEvent(sa(1), sa(2), sa(3))
                        End If
                    Case "save"
                        If sa(1).ToLower = "stringtofile" Then
                            Dim s1 As String = EvalString_AutoQuoting(sa(2))
                            Dim s2 As String = EvalString_AutoQuoting(sa(3)).Trim
                            If s2 <> "" Then
                                ' ---------------------------------------------- the path in the "Files" folder
                                s2 = Application.StartupPath + "\Files\" + s2
                                Dim dir As String = IO.Path.GetDirectoryName(s2)
                                ' ---------------------------------------------- eventually create the "Files" folder
                                If Not IO.Directory.Exists(dir) Then
                                    IO.Directory.CreateDirectory(dir)
                                End If
                                ' ---------------------------------------------- append the string and a NewLine
                                Dim sw As IO.StreamWriter
                                sw = My.Computer.FileSystem.OpenTextFileWriter(s2, _
                                                                               True, _
                                                                               New System.Text.UnicodeEncoding())
                                sw.Write(s1 + vbCrLf)
                                sw.Close()
                            End If
                        End If
                    Case "slot"
                        Select Case sa(3)
                            Case "Reset"
                                Slots.WriteSlot(CInt(EvalDouble(sa(1))), NAN_Reset)
                            Case "Sleep"
                                Slots.WriteSlot(CInt(EvalDouble(sa(1))), NAN_Sleep)
                            Case Else
                                Slots.WriteSlot(CInt(EvalDouble(sa(1))), CSng(EvalDouble(sa(3))))
                        End Select
                    Case Else
                        If sa(1) = "=" Then
                            If sa(2).ToLower = "input" Then
                                If IsSomeVariable(sa(0)) Then
                                    InputDialog_ThreadSafe(sa(0), EvalString_AutoQuoting(sa(3)))
                                End If
                            End If
                        End If
                End Select
            Case 6
                Select Case sa(0).ToLower
                    Case "for"
                        If IsNumericVariable(sa(1)) And sa(2) = "=" And IsValidDouble(sa(3)) And _
                                                        sa(4).ToLower = "to" And IsValidDouble(sa(5)) Then

                            ExecuteFOR(sa(1), _
                                       EvalDouble(sa(3)), _
                                       EvalDouble(sa(5)), _
                                       1, _
                                       PC)
                        End If
                End Select
            Case 8
                Select Case sa(0).ToLower
                    Case "for"
                        If IsNumericVariable(sa(1)) And sa(2) = "=" And IsValidDouble(sa(3)) And _
                                                        sa(4).ToLower = "to" And IsValidDouble(sa(5)) And _
                                                        sa(6).ToLower = "step" And IsValidDouble(sa(7)) Then

                            ExecuteFOR(sa(1), _
                                       EvalDouble(sa(3)), _
                                       EvalDouble(sa(5)), _
                                       Math.Abs(EvalDouble(sa(7))), _
                                       PC)
                        End If
                End Select
        End Select
    End Sub

    ' ===========================================================================================
    '  EXECUTE THE FOR INSTRUCTION
    ' ===========================================================================================
    Private Sub ExecuteFOR(ByVal ControlVariableName As String, _
                           ByVal vInitial As Double, _
                           ByVal vFinal As Double, _
                           ByVal vStep As Double, _
                           ByVal PC As Int32)

        Dim v As Double
        ' --------------------------------------------------- init the control variable value
        If Not JumpingFromNEXT Then
            v = vInitial
            ForNextStack.Push(PC)
        Else
            v = GetNumericVariable(ControlVariableName)
        End If
        ' --------------------------------------------------- set the step sign
        If v > vFinal Then vStep = -vStep
        ' --------------------------------------------------- 
        If JumpingFromNEXT Then
            If v = vFinal Then
                GotoLine = JumpingFromNext_LineIndex + 1
                LineInExecution = JumpingFromNext_LineIndex
                ForNextStack.Pop()
            End If
            ' ----------------------------------------------- increase the control variable value
            v += vStep
            ' ----------------------------------------------- limit the value to vfinal
            If vStep > 0 Then
                If v > vFinal Then v = vFinal
            Else
                If v <= vFinal Then v = vFinal
            End If
            ' ----------------------------------------------- reset the flag
            JumpingFromNEXT = False
        End If
        ' --------------------------------------------------- set the control variable
        SetNumericVariable(ControlVariableName, v)
    End Sub

    ' ===========================================================================================
    '  TRIM THE FOR-NEXT STACK WHEN JUMPING "NEXT" INSTRUCTIONS, WITH GOTO, IN FORWARD DIRECTION
    ' ===========================================================================================
    Private Sub TrimTheForNextStack(ByVal Goto_from As Int32, ByVal Goto_dest As Int32)
        For i As Int32 = Goto_from + 1 To Goto_dest - 1
            If RTBLines(i).Trim.ToLower.StartsWith("next") Then
                ForNextStack.Pop()
            End If
        Next
    End Sub

End Class